#define IN1 9 // Připojení výstupních pinů ke vstupům driveru
#define IN2 8
#define IN3 7
#define IN4 6
#define ENA 10 // Pin pro aktivaci motoru A
#define ENB 5  // Pin pro aktivaci motoru B

int speed = 100; // proměnná pro rychlost, hodnoty od 0 do 255

void setup(){ 
    pinMode(IN1, OUTPUT); // Nastaví piny pro ovládání driveru jako výstupy
    pinMode(IN2, OUTPUT);
    pinMode(IN3, OUTPUT);
    pinMode(IN4, OUTPUT);
    pinMode(ENA, OUTPUT);
    pinMode(ENB, OUTPUT);
}

void loop(){
    forward();   // Jede dopředu
    delay(500);  // Čeká 500 milisekund
    right();     // Jede doprava
    delay(500);  // Čeká 500 milisekund
    stop();      // Zastaví
    delay(3000); // Čeká 3 sekundy
}


void forward(){ // Funkce pro jízdu dopředu
    digitalWrite(IN1, LOW);
    digitalWrite(IN2, HIGH);
    digitalWrite(IN3, LOW);
    digitalWrite(IN4, HIGH);
    analogWrite(ENA, speed);
    analogWrite(ENB, speed);
}

void back(){ // Funkce pro jízdu dozadu
    digitalWrite(IN1, HIGH);
    digitalWrite(IN2, LOW);
    digitalWrite(IN3, HIGH);
    digitalWrite(IN4, LOW);
    analogWrite(ENA, speed);
    analogWrite(ENB, speed);
}

void left(){ // Funkce pro zatáčení doleva
    digitalWrite(IN1, LOW);
    digitalWrite(IN2, HIGH);
    digitalWrite(IN3, HIGH);
    digitalWrite(IN4, LOW);
    analogWrite(ENA, speed);
    analogWrite(ENB, speed);
}

void right(){ // Funkce pro zatáčení doprava
    digitalWrite(IN1, HIGH);
    digitalWrite(IN2, LOW);
    digitalWrite(IN3, LOW);
    digitalWrite(IN4, HIGH);
    analogWrite(ENA, speed);
    analogWrite(ENB, speed);
}

void stop(){ // Funkce pro zastavení robota
  digitalWrite(ENA, LOW);
  digitalWrite(ENB, LOW);
}
